import { QueryKey, UseQueryOptions } from "react-query";
import { Query, QuerySnapshot, DocumentData, Firestore, SnapshotOptions } from "firebase/firestore";
import { UseFirestoreHookOptions } from "./index";
declare type NamedQueryPromise<T> = () => Promise<Query<T> | null>;
declare type NamedQuery<T> = Query<T> | NamedQueryPromise<T>;
declare type QueryType<T> = Query<T> | NamedQuery<T>;
export declare function namedQuery<T>(firestore: Firestore, name: string): NamedQuery<T>;
export declare function useFirestoreQuery<T = DocumentData, R = QuerySnapshot<T>>(key: QueryKey, query: QueryType<T>, options?: UseFirestoreHookOptions, useQueryOptions?: UseQueryOptions<QuerySnapshot<T>, Error, R>): import("react-query").UseQueryResult<R, Error>;
export declare function useFirestoreQueryData<T = DocumentData, R = T>(key: QueryKey, query: QueryType<T>, options?: UseFirestoreHookOptions & SnapshotOptions, useQueryOptions?: UseQueryOptions<T[], Error, R>): import("react-query").UseQueryResult<R, Error>;
export {};
